/*
 * 推送模块相关代码 
 * delan@itwlw.com 2016.6.25
 */
var appPush = (function(w) {

	function listenPush() {
		var clientInfo = plus.push.getClientInfo();
		var clientID = clientInfo.clientid;
		var pushPayload = {};

		logoutPushMsg('init user info', JSON.stringify(clientInfo), clientID);
		// 监听点击消息事件 
		plus.push.addEventListener("click", function(msg) {
			// 判断是从本地创建还是离线推送的消息	    
	        logoutPushMsg('click payload obj', JSON.stringify(msg.payload), clientID);
	        logoutPushMsg('click msginfo', JSON.stringify(msg), clientID);   
			switch(msg.payload) {
				case "LocalMSG":
					console.log("点击本地创建消息启动：");
					break;
				default:
					console.log("点击离线推送消息启动：");
					logoutPushMsg('click server', msg.content, clientID);	
					if(msg.payload.payload.url){
						logoutPushMsg('jump to url', msg.payload.payload.url, clientID);	      
	                 	openTargetUrl(msg.payload.payload.url);
	                 	return true;
					}      
					break;
			}
			pushPayload = msg.payload?JSON.parse(msg.payload):{};
			if(pushPayload.url) {
		      	logoutPushMsg('payload click', pushPayload.url, clientID);
				openTargetUrl(pushPayload.url);
			}
		}, false);

		// 监听在线消息事件
		plus.push.addEventListener("receive", function(msg) {
			logoutPushMsg('receive msginfo', JSON.stringify(msg), clientID);
			if(msg.aps) { // Apple APNS message
				console.log("接收到在线APNS消息：");

			} else {
				console.log("接收到在线透传消息：");

			}
			if(msg.payload) {
				if(typeof(msg.payload) == "string") {
					pushPayload = msg.payload ? JSON.parse(msg.payload) : {};
				} else {
					pushPayload = msg.payload;
				}
				if(pushPayload.url) {
					plus.nativeUI.confirm(msg.content, function(e) {
						if(e.index == 0) {
							logoutPushMsg('payload receive', pushPayload.url, clientID);
							openTargetUrl(pushPayload.url);
						}
					}, "趣测", ["立即查看", "忽略"]);
				}
			}

		}, false);
	}

	function openTargetUrl(url) {
		clicked(url);
	}

	function logoutPushMsg(type, content, clientID) {
		console.log('logoutPushMsg');
		/*var apiHost = "http://funny.pv.woquhudong.cn/";
		var pushServer = apiHost + 'index.php/App/Index/pushRecord';
		mui.post(pushServer,{
				type:type,
				content:content,
				clientid:clientID
			},function(data){
				
			},'json');*/
	}

	function createLocalPushMsg() {
		var options = { cover: false };
		var str = ": 欢迎使用Html5 Plus创建本地消息！";
		plus.push.createMessage(str, '{"title":"怪哥有更新啦","content":"孕检单生成器","payload":{"url":"http://funny.pv.itwlw.com/index.php/home/funny/play/name/conceive"}}', options);
		console.log("创建本地消息成功！");
		console.log("请到系统消息中心查看！");
		if(plus.os.name == "iOS") {
			console.log('*如果无法创建消息，请到"设置"->"通知"中配置应用在通知中心显示!');
		}
	}

	if(w.plus) {
		listenPush();

	} else {
		document.addEventListener("plusready", listenPush, false);

	}

})(window);